<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.14" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="group__group__hal__syspm" kind="group">
    <compoundname>group_hal_syspm</compoundname>
    <title>System Power Management</title>
    <innerclass prot="public" refid="structcyhal__syspm__callback__data__t">cyhal_syspm_callback_data_t</innerclass>
    <innergroup refid="group__group__hal__results__syspm">SYSPM HAL Results</innergroup>
      <sectiondef kind="enum">
      <memberdef id="group__group__hal__syspm_1ga560aa7873d3131c4eb5d1453711305d2" kind="enum" prot="public" static="no" strong="no">
        <type />
        <name>cyhal_syspm_callback_state_t</name>
        <enumvalue id="group__group__hal__syspm_1gga560aa7873d3131c4eb5d1453711305d2a30f5d217aded3c5525b1d9cea03ac5a8" prot="public">
          <name>CYHAL_SYSPM_CB_CPU_SLEEP</name>
          <initializer>= 0x01U</initializer>
          <briefdescription>
<para>Flag for MCU sleep callback. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__syspm_1gga560aa7873d3131c4eb5d1453711305d2aeaae71eba11b9c861e4a86a6f5c0f2aa" prot="public">
          <name>CYHAL_SYSPM_CB_CPU_DEEPSLEEP</name>
          <initializer>= 0x02U</initializer>
          <briefdescription>
<para>Flag for MCU deep sleep callback. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__syspm_1gga560aa7873d3131c4eb5d1453711305d2ac9de4348b02a53d947ce48bd7bc6922a" prot="public">
          <name>CYHAL_SYSPM_CB_SYSTEM_HIBERNATE</name>
          <initializer>= 0x04U</initializer>
          <briefdescription>
<para>Flag for Hibernate callback. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__syspm_1gga560aa7873d3131c4eb5d1453711305d2aca71bfa3460ce92a9eed50dace3b8b5a" prot="public">
          <name>CYHAL_SYSPM_CB_SYSTEM_NORMAL</name>
          <initializer>= 0x08U</initializer>
          <briefdescription>
<para>Flag for Normal mode callback. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__syspm_1gga560aa7873d3131c4eb5d1453711305d2af13d1c94115a90b1f9d734ace0017045" prot="public">
          <name>CYHAL_SYSPM_CB_SYSTEM_LOW</name>
          <initializer>= 0x10U</initializer>
          <briefdescription>
<para>Flag for Low power mode callback. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <briefdescription>
<para><bold>cyhal_syspm_callback_state_t: </bold><linebreak />Flags enum for the cpu state in a custom callback.</para></briefdescription>
        <detaileddescription>
<para>This is used to indicate what states a callback should be called in. When a callback is called, only one of these will be set at a time. </para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="174" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_general_types.h" bodystart="167" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_general_types.h" line="168" />
      </memberdef>
      <memberdef id="group__group__hal__syspm_1ga5a6a88eb2b6e35dbea25e36b027bf4ba" kind="enum" prot="public" static="no" strong="no">
        <type />
        <name>cyhal_syspm_callback_mode_t</name>
        <enumvalue id="group__group__hal__syspm_1gga5a6a88eb2b6e35dbea25e36b027bf4baa1d8aad9b05d313a22e7666a98414f26d" prot="public">
          <name>CYHAL_SYSPM_CHECK_READY</name>
          <initializer>= 0x01U</initializer>
          <briefdescription>
<para>Callbacks with this mode are executed before entering into the low power mode. </para>          </briefdescription>
          <detaileddescription>
<para>The purpose of this transition state is to check if the device is ready to enter the low power mode. The application must not perform any actions that would prevent transition after returning true for this mode. </para>          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__syspm_1gga5a6a88eb2b6e35dbea25e36b027bf4baa190eae9b4e71d4c245038320880dcca3" prot="public">
          <name>CYHAL_SYSPM_CHECK_FAIL</name>
          <initializer>= 0x02U</initializer>
          <briefdescription>
<para>Callbacks with this mode are only executed if the callback returned true for CYHAL_SYSPM_CHECK_READY and a later callback returns false for CYHAL_SYSPM_CHECK_READY. </para>          </briefdescription>
          <detaileddescription>
<para>This mode should roll back any changes made to avoid blocking transition made in CYHAL_SYSPM_CHECK_READY mode </para>          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__syspm_1gga5a6a88eb2b6e35dbea25e36b027bf4baadd83c77cb81d9d4aafef1d094e6c4e71" prot="public">
          <name>CYHAL_SYSPM_BEFORE_TRANSITION</name>
          <initializer>= 0x04U</initializer>
          <briefdescription>
<para>Callbacks with this mode are executed after the CYHAL_SYSPM_CHECK_READY callbacks' execution returns true. </para>          </briefdescription>
          <detaileddescription>
<para>In this mode, the application must perform the actions to be done before entering into the low power mode. </para>          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__syspm_1gga5a6a88eb2b6e35dbea25e36b027bf4baaf6a195dbd042da0bffc35b9161ca49e6" prot="public">
          <name>CYHAL_SYSPM_AFTER_TRANSITION</name>
          <initializer>= 0x08U</initializer>
          <briefdescription>
<para>In this mode, the application must perform the actions to be done after exiting the low power mode. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <briefdescription>
<para><bold>cyhal_syspm_callback_mode_t: </bold><linebreak />Enumeration of the transition modes in custom callback.</para></briefdescription>
        <detaileddescription>
<para>The general sequence is: CHECK_READY, BEFORE_TRANSITION, AFTER_TRANSITION. If any callback indicates that it is not able to change state as part of CHECK_READY, CHECK_FAIL will be run instead of the BEFORE/AFTER_TRANSITION. </para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="204" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_general_types.h" bodystart="188" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_general_types.h" line="189" />
      </memberdef>
      <memberdef id="group__group__hal__syspm_1ga144e474d3bfb544b207f172d1d8bd633" kind="enum" prot="public" static="no" strong="no">
        <type />
        <name>cyhal_syspm_system_state_t</name>
        <enumvalue id="group__group__hal__syspm_1gga144e474d3bfb544b207f172d1d8bd633acd2a5522b6591eb77418369e464a3eb1" prot="public">
          <name>CYHAL_SYSPM_SYSTEM_NORMAL</name>
          <briefdescription>
<para>Normal Mode. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__syspm_1gga144e474d3bfb544b207f172d1d8bd633af4060b98561e43a6b930576644af014f" prot="public">
          <name>CYHAL_SYSPM_SYSTEM_LOW</name>
          <briefdescription>
<para>Low Power Mode. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <briefdescription>
<para><bold>cyhal_syspm_system_state_t: </bold><linebreak />Enumeration of the system wide power modes.</para></briefdescription>
        <detaileddescription>
<para>These modes are device specifc and may not be supported on all devices. Refer to the device specific documentation or the Data Sheet to determine what is allowed. Devices that do support these modes may have requirements for adjusting system settings such as clocks or voltage levels before transition. </para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="200" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_syspm.h" bodystart="196" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_syspm.h" line="197" />
      </memberdef>
      <memberdef id="group__group__hal__syspm_1ga716955af458772e538910575cbf6e1dd" kind="enum" prot="public" static="no" strong="no">
        <type />
        <name>cyhal_syspm_hibernate_source_t</name>
        <enumvalue id="group__group__hal__syspm_1gga716955af458772e538910575cbf6e1dda57c81752ef79a93b9a9701c59a8b35e3" prot="public">
          <name>CYHAL_SYSPM_HIBERNATE_LPCOMP0_LOW</name>
          <initializer>= 0x01U</initializer>
          <briefdescription>
<para>Wake on a low logic level for the LPComp0. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__syspm_1gga716955af458772e538910575cbf6e1dda765ef14d1cc8c55710c122b77798204b" prot="public">
          <name>CYHAL_SYSPM_HIBERNATE_LPCOMP0_HIGH</name>
          <initializer>= 0x02U</initializer>
          <briefdescription>
<para>Wake on a high logic level for the LPComp0. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__syspm_1gga716955af458772e538910575cbf6e1dda0a4d1ab39bb8cbece570a555971bcd99" prot="public">
          <name>CYHAL_SYSPM_HIBERNATE_LPCOMP1_LOW</name>
          <initializer>= 0x04U</initializer>
          <briefdescription>
<para>Wake on a low logic level for the LPComp1. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__syspm_1gga716955af458772e538910575cbf6e1dda46ab6d77f810acb319caff3616a8f88c" prot="public">
          <name>CYHAL_SYSPM_HIBERNATE_LPCOMP1_HIGH</name>
          <initializer>= 0x08U</initializer>
          <briefdescription>
<para>Wake on a high logic level for the LPComp1. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__syspm_1gga716955af458772e538910575cbf6e1dda2a495fcdf84252843b6fc9bc4e27206a" prot="public">
          <name>CYHAL_SYSPM_HIBERNATE_RTC_ALARM</name>
          <initializer>= 0x10U</initializer>
          <briefdescription>
<para>Configure the RTC alarm as wakeup source. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__syspm_1gga716955af458772e538910575cbf6e1dda519c726a562e214bd1694137e62a22e1" prot="public">
          <name>CYHAL_SYSPM_HIBERNATE_WDT</name>
          <initializer>= 0x20U</initializer>
          <briefdescription>
<para>Configure the WDT interrupt as wakeup source. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__syspm_1gga716955af458772e538910575cbf6e1dda9ccdbb4f654ce023bea0fafba50cab53" prot="public">
          <name>CYHAL_SYSPM_HIBERNATE_PINA_LOW</name>
          <initializer>= 0x40U</initializer>
          <briefdescription>
<para>Configure a low logic level for the first wakeup-pin. </para>          </briefdescription>
          <detaileddescription>
<para>See device datasheet for specific pin. </para>          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__syspm_1gga716955af458772e538910575cbf6e1dda0882eed07391eb7773ea2f4c47a7b5ff" prot="public">
          <name>CYHAL_SYSPM_HIBERNATE_PINA_HIGH</name>
          <initializer>= 0x80U</initializer>
          <briefdescription>
<para>Configure a high logic level for the first wakeup-pin. </para>          </briefdescription>
          <detaileddescription>
<para>See device datasheet for specific pin. </para>          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__syspm_1gga716955af458772e538910575cbf6e1dda1bf3cfcfb69b48e6b0ef5a525cc6eb3d" prot="public">
          <name>CYHAL_SYSPM_HIBERNATE_PINB_LOW</name>
          <initializer>= 0x100U</initializer>
          <briefdescription>
<para>Configure a low logic level for the second wakeup-pin. </para>          </briefdescription>
          <detaileddescription>
<para>See device datasheet for specific pin. </para>          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__syspm_1gga716955af458772e538910575cbf6e1dda69f639b3f33245d1a789fd443b94b47d" prot="public">
          <name>CYHAL_SYSPM_HIBERNATE_PINB_HIGH</name>
          <initializer>= 0x200U</initializer>
          <briefdescription>
<para>Configure a high logic level for the second wakeup-pin. </para>          </briefdescription>
          <detaileddescription>
<para>See device datasheet for specific pin. </para>          </detaileddescription>
        </enumvalue>
        <briefdescription>
<para><bold>cyhal_syspm_hibernate_source_t: </bold><linebreak />Flags enum for the hibernate wakeup sources.</para></briefdescription>
        <detaileddescription>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;Not all wakeup sources are valid on devices. Refer to the datasheet for device specifics. &lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim></para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="222" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_syspm.h" bodystart="206" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_syspm.h" line="207" />
      </memberdef>
      <memberdef id="group__group__hal__syspm_1ga843f8267deb62a570fff3ce7ebf1a6c4" kind="enum" prot="public" static="no" strong="no">
        <type />
        <name>cyhal_syspm_voltage_supply_t</name>
        <enumvalue id="group__group__hal__syspm_1gga843f8267deb62a570fff3ce7ebf1a6c4af5c399ada3960bb3f5e6784be9bdccc9" prot="public">
          <name>CYHAL_VOLTAGE_SUPPLY_VDDA</name>
          <initializer>= 0u</initializer>
          <briefdescription>
<para>VDDA - Analog supply voltage. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__syspm_1gga843f8267deb62a570fff3ce7ebf1a6c4a072774e669a76b4999d596b27bf897b0" prot="public">
          <name>CYHAL_VOLTAGE_SUPPLY_MAX</name>
          <initializer>= CYHAL_VOLTAGE_SUPPLY_VDDA</initializer>
          <briefdescription>
<para>Alias for the highest value in this enum. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <briefdescription>
<para><bold>cyhal_syspm_voltage_supply_t: </bold><linebreak />Supply voltages whose levels can be specified and queried via <ref kindref="member" refid="group__group__hal__syspm_1ga01d10df7bebeb345902a0d8e1c193ad1">cyhal_syspm_set_supply_voltage</ref> and <ref kindref="member" refid="group__group__hal__syspm_1ga6bbb8993f1add4b31d7b168fb670f842">cyhal_syspm_get_supply_voltage</ref>, respectively.</para></briefdescription>
        <detaileddescription>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;Not all supplies which are present are included here. This enum only contains the voltage supplies whose values are relevant to the operation of one or more HAL drivers. &lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim></para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="234" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_syspm.h" bodystart="230" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_syspm.h" line="231" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="typedef">
      <memberdef id="group__group__hal__syspm_1ga19c98edec42da617e97eb09ea9292514" kind="typedef" prot="public" static="no">
        <type>bool(*</type>
        <definition>typedef bool(* cyhal_syspm_callback_t) (cyhal_syspm_callback_state_t state, cyhal_syspm_callback_mode_t mode, void *callback_arg)</definition>
        <argsstring>)(cyhal_syspm_callback_state_t state, cyhal_syspm_callback_mode_t mode, void *callback_arg)</argsstring>
        <name>cyhal_syspm_callback_t</name>
        <briefdescription>
<para>The system wide custom action power callback type. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">state</parametername>
</parameternamelist>
<parameterdescription>
<para>State the system or CPU is being transitioned into. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">mode</parametername>
</parameternamelist>
<parameterdescription>
<para>Callback mode. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">callback_arg</parametername>
</parameternamelist>
<parameterdescription>
<para>User argument passed as part of registering callback in <ref kindref="member" refid="group__group__hal__syspm_1ga5d1637ece9b27528636981acfc893fd3">cyhal_syspm_register_callback</ref>. </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>If mode is <ref kindref="member" refid="group__group__hal__syspm_1gga5a6a88eb2b6e35dbea25e36b027bf4baa1d8aad9b05d313a22e7666a98414f26d">CYHAL_SYSPM_CHECK_READY</ref>, then this indicates whether the low power mode should be allowed (true) or not (false). Otherwise the return value is ignored. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_general_types.h" bodystart="214" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_general_types.h" line="214" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="func">
      <memberdef const="no" explicit="no" id="group__group__hal__syspm_1ga507445e44ab6aae0f4cbaabaec6c5a3f" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_syspm_hibernate</definition>
        <argsstring>(cyhal_syspm_hibernate_source_t wakeup_source)</argsstring>
        <name>cyhal_syspm_hibernate</name>
        <param>
          <type><ref kindref="member" refid="group__group__hal__syspm_1ga716955af458772e538910575cbf6e1dd">cyhal_syspm_hibernate_source_t</ref></type>
          <declname>wakeup_source</declname>
        </param>
        <briefdescription>
<para>Sets the system mode to hibernate. </para>        </briefdescription>
        <detaileddescription>
<para>This function configures the sources to wake up the device from hibernate mode and then sets the system to hibernate mode.</para><para>In hibernate mode, all internal supplies are off and no internal state is retained.</para><para>Sources can be wakeup pins, LPComparators, Watchdog (WDT) interrupt, or a Real-Time clock (RTC) alarm (interrupt). Wakeup from system hibernate always results in a device reset and normal boot process.</para><para>Wakeup pins:</para><para>A wakeup is supported by pins with programmable polarity. These pins are typically connected to the GPIO pins or on-chip peripherals under some conditions. See device datasheet to check if this feature is supported and for specific pin connections. Setting the wakeup pin to this level will cause a wakeup from system hibernate mode.</para><para>LPComparators:</para><para>A wakeup is supported by LPComps with programmable polarity. Setting the LPComp to this level will cause a wakeup from system hibernate mode.</para><para>Watchdog Timer:</para><para>A wakeup is performed by a WDT interrupt.</para><para>Real-time Clock:</para><para>A wakeup is performed by the RTC alarm.</para><para>For information about hibernate behavior, wakeup sources and their assignment in specific devices, refer to the appropriate device TRM.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">wakeup_source</parametername>
</parameternamelist>
<parameterdescription>
<para>The source to be configured as a wakeup source from the system hibernate power mode, see <ref kindref="member" refid="group__group__hal__syspm_1ga716955af458772e538910575cbf6e1dd">cyhal_syspm_hibernate_source_t</ref>. The input parameter values can be ORed. For example, if you want to enable LPComp0 (active high) and WDT, call this function: cyhal_syspm_hibernate(CYHAL_SYSPM_HIBERNATE_LPCOMP0_HIGH | CYHAL_SYSPM_HIBERNATE_WDT).</para></parameterdescription>
</parameteritem>
</parameterlist>
<verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition warning"&gt;&lt;p class="admonition-title"&gt;warning&lt;/p&gt;&lt;p&gt;&lt;p&gt;Do not call this function with different polarity levels for the same wakeup source. For example, do not call a function like this: cyhal_syspm_hibernate(CYHAL_SYSPM_HIBERNATE_LPCOMP0_LOW | CYHAL_SYSPM_HIBERNATE_LPCOMP0_HIGH);&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><simplesect kind="return"><para>Returns CY_RSLT_SUCCESS if the processor successfully entered the hibernate mode, otherwise error. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="312" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_syspm.c" bodystart="287" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_syspm.h" line="285" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__syspm_1gaae0157682bad1b2155738e73347afa87" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_syspm_set_system_state</definition>
        <argsstring>(cyhal_syspm_system_state_t state)</argsstring>
        <name>cyhal_syspm_set_system_state</name>
        <param>
          <type><ref kindref="member" refid="group__group__hal__syspm_1ga144e474d3bfb544b207f172d1d8bd633">cyhal_syspm_system_state_t</ref></type>
          <declname>state</declname>
        </param>
        <briefdescription>
<para>Set the system-wide state of the device. </para>        </briefdescription>
        <detaileddescription>
<para>This is used to change the power state within the Active power mode. <ref kindref="member" refid="group__group__hal__syspm_1gaf5aec2878d9a38835444befb25e274fe">cyhal_syspm_get_system_state</ref> can be used to get the current state. <verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;Not all devices support different states within the Active power mode. If the device does not support changing state, an error will be returned.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">state</parametername>
</parameternamelist>
<parameterdescription>
<para>System wide state.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>Returns CY_RSLT_SUCCESS if the processor successfully entered the requested system state, otherwise error. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="343" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_syspm.c" bodystart="314" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_syspm.h" line="298" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__syspm_1gaf5aec2878d9a38835444befb25e274fe" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__hal__syspm_1ga144e474d3bfb544b207f172d1d8bd633">cyhal_syspm_system_state_t</ref></type>
        <definition>cyhal_syspm_system_state_t cyhal_syspm_get_system_state</definition>
        <argsstring>()</argsstring>
        <name>cyhal_syspm_get_system_state</name>
        <briefdescription>
<para>Gets the system-wide state of the device. </para>        </briefdescription>
        <detaileddescription>
<para>States can be changed by calling <ref kindref="member" refid="group__group__hal__syspm_1gaae0157682bad1b2155738e73347afa87">cyhal_syspm_set_system_state</ref>. <verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;Not all devices support different states within the Active power mode. If the device does not support changing state, this will return &lt;a href="group__group__hal__syspm.html#group__group__hal__syspm_1gga144e474d3bfb544b207f172d1d8bd633acd2a5522b6591eb77418369e464a3eb1"&gt;CYHAL_SYSPM_SYSTEM_NORMAL&lt;/a&gt;. &lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><simplesect kind="return"><para>Returns the current system-wide power state of the device. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_syspm.h" line="307" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__syspm_1ga5d1637ece9b27528636981acfc893fd3" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void cyhal_syspm_register_callback</definition>
        <argsstring>(cyhal_syspm_callback_data_t *callback_data)</argsstring>
        <name>cyhal_syspm_register_callback</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__syspm__callback__data__t">cyhal_syspm_callback_data_t</ref> *</type>
          <declname>callback_data</declname>
        </param>
        <briefdescription>
<para>Register the specified handler with the power manager to be notified of power state changes. </para>        </briefdescription>
        <detaileddescription>
<para>This is intended for application wide decisions. Peripherals handle their ability to perform power transitions internally. This callback will be called before any of the peripheral callbacks for <ref kindref="member" refid="group__group__hal__syspm_1gga5a6a88eb2b6e35dbea25e36b027bf4baa1d8aad9b05d313a22e7666a98414f26d">CYHAL_SYSPM_CHECK_READY</ref> and <ref kindref="member" refid="group__group__hal__syspm_1gga5a6a88eb2b6e35dbea25e36b027bf4baadd83c77cb81d9d4aafef1d094e6c4e71">CYHAL_SYSPM_BEFORE_TRANSITION</ref>. This callback will be called after all peripheral callback for <ref kindref="member" refid="group__group__hal__syspm_1gga5a6a88eb2b6e35dbea25e36b027bf4baa190eae9b4e71d4c245038320880dcca3">CYHAL_SYSPM_CHECK_FAIL</ref> and <ref kindref="member" refid="group__group__hal__syspm_1gga5a6a88eb2b6e35dbea25e36b027bf4baaf6a195dbd042da0bffc35b9161ca49e6">CYHAL_SYSPM_AFTER_TRANSITION</ref>. <verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;The callback will be executed from a critical section&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">callback_data</parametername>
</parameternamelist>
<parameterdescription>
<para>The data for the callback to register </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="355" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_syspm.c" bodystart="345" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_syspm.h" line="319" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__syspm_1gae069670790199a668edffa9ec01fd538" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void cyhal_syspm_unregister_callback</definition>
        <argsstring>(cyhal_syspm_callback_data_t *callback_data)</argsstring>
        <name>cyhal_syspm_unregister_callback</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__syspm__callback__data__t">cyhal_syspm_callback_data_t</ref> *</type>
          <declname>callback_data</declname>
        </param>
        <briefdescription>
<para>Removes the registered handler from the power manager so no future notifications are made. </para>        </briefdescription>
        <detaileddescription>
<para><itemizedlist>
<listitem><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">callback_data</parametername>
</parameternamelist>
<parameterdescription>
<para>The data for the callback to unregister </para></parameterdescription>
</parameteritem>
</parameterlist>
</para></listitem></itemizedlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="360" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_syspm.c" bodystart="357" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_syspm.h" line="325" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__syspm_1gac3e07ce98d215865b0f7f0149073bae2" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_syspm_sleep</definition>
        <argsstring>(void)</argsstring>
        <name>cyhal_syspm_sleep</name>
        <param>
          <type>void</type>
        </param>
        <briefdescription>
<para>Set CPU to sleep mode. </para>        </briefdescription>
        <detaileddescription>
<para><simplesect kind="return"><para>Returns CY_RSLT_SUCCESS if the processor successfully entered the sleep mode , otherwise error. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_syspm.h" line="332" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__syspm_1ga0afe7e58c0df4a2eda5010ac628ea981" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_syspm_deepsleep</definition>
        <argsstring>(void)</argsstring>
        <name>cyhal_syspm_deepsleep</name>
        <param>
          <type>void</type>
        </param>
        <briefdescription>
<para>Set CPU to deep sleep mode. </para>        </briefdescription>
        <detaileddescription>
<para><simplesect kind="return"><para>Returns CY_RSLT_SUCCESS if the processor successfully entered the deep sleep mode, otherwise error. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_syspm.h" line="339" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__syspm_1ga3568214a6038240239f99768fe6707d6" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void cyhal_syspm_lock_deepsleep</definition>
        <argsstring>(void)</argsstring>
        <name>cyhal_syspm_lock_deepsleep</name>
        <param>
          <type>void</type>
        </param>
        <briefdescription>
<para>Lock deep sleep. </para>        </briefdescription>
        <detaileddescription>
<para>This function prevents the CPU from going to deep sleep. The lock is implemented as a counter from 0 to USHRT_MAX. Each call to this function increments the counter by 1. <ref kindref="member" refid="group__group__hal__syspm_1ga028b85f03d4607ccac8494b46ec8413c">cyhal_syspm_unlock_deepsleep</ref> must be called an equal number of times to fully unlock. Deepsleep will only be allowed when the counter is equal to 0. </para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="371" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_syspm.c" bodystart="362" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_syspm.h" line="348" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__syspm_1ga028b85f03d4607ccac8494b46ec8413c" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void cyhal_syspm_unlock_deepsleep</definition>
        <argsstring>(void)</argsstring>
        <name>cyhal_syspm_unlock_deepsleep</name>
        <param>
          <type>void</type>
        </param>
        <briefdescription>
<para>Unlock deep sleep. </para>        </briefdescription>
        <detaileddescription>
<para>This function decrements the lock counter by 1 and must be called an equal number of times as <ref kindref="member" refid="group__group__hal__syspm_1ga3568214a6038240239f99768fe6707d6">cyhal_syspm_lock_deepsleep</ref> is called to fully unlock. Deepsleep will only be allowed when the counter is equal to 0. </para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="382" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_syspm.c" bodystart="373" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_syspm.h" line="356" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__syspm_1ga2217e0c4c24cc5fe14d5765681de191d" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_syspm_tickless_deepsleep</definition>
        <argsstring>(cyhal_lptimer_t *obj, uint32_t desired_ms, uint32_t *actual_ms)</argsstring>
        <name>cyhal_syspm_tickless_deepsleep</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__lptimer__t">cyhal_lptimer_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>desired_ms</declname>
        </param>
        <param>
          <type>uint32_t *</type>
          <declname>actual_ms</declname>
        </param>
        <briefdescription>
<para>Timed deep-sleep without system timer. </para>        </briefdescription>
        <detaileddescription>
<para>Provides a way to deep-sleep for a desired number of milliseconds(ms) with the system timer disabled. The system timer is disabled before sleeping and a low power timer is setup to wake the device from deep-sleep after the desired number of ms have elapsed.</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;The actual ms in the best case will be 1 ms less than the desired time to prevent the device from over-sleeping due to low clock accuracy.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>Pre-Initialized LPTimer object. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">desired_ms</parametername>
</parameternamelist>
<parameterdescription>
<para>Desired number of ms to deep-sleep. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="out">actual_ms</parametername>
</parameternamelist>
<parameterdescription>
<para>Actual number of ms that was spent in deep-sleep. This value can range from 0 to desired_ms - 1 depending on how long the device was able to deep-sleep. </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the deep-sleep request. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_syspm.h" line="374" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__syspm_1ga777835c494bbea3923a4cf9795249fd6" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_syspm_tickless_sleep</definition>
        <argsstring>(cyhal_lptimer_t *obj, uint32_t desired_ms, uint32_t *actual_ms)</argsstring>
        <name>cyhal_syspm_tickless_sleep</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__lptimer__t">cyhal_lptimer_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>desired_ms</declname>
        </param>
        <param>
          <type>uint32_t *</type>
          <declname>actual_ms</declname>
        </param>
        <briefdescription>
<para>Timed sleep without system timer. </para>        </briefdescription>
        <detaileddescription>
<para>Provides a way to sleep for a desired number of milliseconds(ms) with the system timer disabled. The system timer is disabled before sleeping and a low power timer is setup to wake the device from sleep after the desired number of ms have elapsed.</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;The actual ms in the best case will be 1 ms less than the desired time to prevent the device from over-sleeping due to low clock accuracy.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>Pre-Initialized LPTimer object. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">desired_ms</parametername>
</parameternamelist>
<parameterdescription>
<para>Desired number of ms to sleep. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="out">actual_ms</parametername>
</parameternamelist>
<parameterdescription>
<para>Actual number of ms that was spent in sleep. This value can range from 0 to desired_ms - 1 depending on how long the device was able to sleep. </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the sleep request. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_syspm.h" line="392" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__syspm_1ga01d10df7bebeb345902a0d8e1c193ad1" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void cyhal_syspm_set_supply_voltage</definition>
        <argsstring>(cyhal_syspm_voltage_supply_t supply, uint32_t mvolts)</argsstring>
        <name>cyhal_syspm_set_supply_voltage</name>
        <param>
          <type><ref kindref="member" refid="group__group__hal__syspm_1ga843f8267deb62a570fff3ce7ebf1a6c4">cyhal_syspm_voltage_supply_t</ref></type>
          <declname>supply</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>mvolts</declname>
        </param>
        <briefdescription>
<para>Informs the system of the current voltage level on the specified supply. </para>        </briefdescription>
        <detaileddescription>
<para>This is generally expected to be set once at system startup, but it may be set repeatedly during runtime if operating conditions change. Once set, this value can be queried via <ref kindref="member" refid="group__group__hal__syspm_1ga6bbb8993f1add4b31d7b168fb670f842">cyhal_syspm_get_supply_voltage</ref>.</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;This only informs the system of the voltage level. It does not alter any of the device operating conditions.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>supply</parametername>
</parameternamelist>
<parameterdescription>
<para>The supply whose voltage is being specified. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>mvolts</parametername>
</parameternamelist>
<parameterdescription>
<para>The voltage level on the specified supply, in millivolts. </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="443" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_syspm.c" bodystart="439" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_syspm.h" line="405" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__syspm_1ga6bbb8993f1add4b31d7b168fb670f842" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>uint32_t</type>
        <definition>uint32_t cyhal_syspm_get_supply_voltage</definition>
        <argsstring>(cyhal_syspm_voltage_supply_t supply)</argsstring>
        <name>cyhal_syspm_get_supply_voltage</name>
        <param>
          <type><ref kindref="member" refid="group__group__hal__syspm_1ga843f8267deb62a570fff3ce7ebf1a6c4">cyhal_syspm_voltage_supply_t</ref></type>
          <declname>supply</declname>
        </param>
        <briefdescription>
<para>Retrieves the current voltage level on the specified supply, as set in <ref kindref="member" refid="group__group__hal__syspm_1ga01d10df7bebeb345902a0d8e1c193ad1">cyhal_syspm_set_supply_voltage</ref>. </para>        </briefdescription>
        <detaileddescription>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;This only returns the value provided to &lt;a href="group__group__hal__syspm.html#group__group__hal__syspm_1ga01d10df7bebeb345902a0d8e1c193ad1"&gt;cyhal_syspm_set_supply_voltage&lt;/a&gt;. It does not perform any measurements of the current supply level.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>supply</parametername>
</parameternamelist>
<parameterdescription>
<para>The supply whose voltage is being specified. </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The voltage level on the specified supply, in millivolts. If the voltage has not been specified, returns 0. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="449" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_syspm.c" bodystart="445" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_syspm.h" line="416" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="define">
      <memberdef id="group__group__hal__syspm_1ga76ba531d277abb20e430874026756664" kind="define" prot="public" static="no">
        <name>CYHAL_SYSPM_CALLBACK_STATE_ALL</name>
        <initializer>(CYHAL_SYSPM_CB_CPU_SLEEP\
                                        | CYHAL_SYSPM_CB_CPU_DEEPSLEEP\
                                        | CYHAL_SYSPM_CB_SYSTEM_HIBERNATE\
                                        | CYHAL_SYSPM_CB_SYSTEM_NORMAL\
                                        | <ref kindref="member" refid="group__group__hal__syspm_1gga560aa7873d3131c4eb5d1453711305d2af13d1c94115a90b1f9d734ace0017045">CYHAL_SYSPM_CB_SYSTEM_LOW</ref>)</initializer>
        <briefdescription>
<para>Define for enabling all system and MCU state callbacks . </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_general_types.h" bodystart="177" column="9" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_general_types.h" line="177" />
      </memberdef>
      </sectiondef>
    <briefdescription>
<para>Interface for changing power states and restricting when they are allowed. </para>    </briefdescription>
    <detaileddescription>
<para>Power management is handled both at a system level and at a peripheral driver level. The system wide API (this) allows the user to interact with the product as a whole. Additionally, each peripheral keeps track of what its state is and whether it can safely move to a new state while still maintaining any current operations.</para><para>At the System level, the APIs are intended to allow the application to specify exactly what is happening. It can request changes to both the MCU Power State as well as the System Wide Power State. There are three supported MCU Power States:<itemizedlist>
<listitem><para>Active - This is the normal operating state of the MCU</para></listitem><listitem><para>Sleep - In this state the MCU is no longer running. It can be woken up again from an interrupt. This state is reached by calling <ref kindref="member" refid="group__group__hal__syspm_1gac3e07ce98d215865b0f7f0149073bae2">cyhal_syspm_sleep</ref>.</para></listitem><listitem><para>Deep Sleep - In this state the MCU is no longer running. It can only be woken up by select interrupts. This state is reached by calling <ref kindref="member" refid="group__group__hal__syspm_1ga0afe7e58c0df4a2eda5010ac628ea981">cyhal_syspm_deepsleep</ref>. </para></listitem></itemizedlist>
</para><para>Additionally, there are three supported system states:<itemizedlist>
<listitem><para>Normal (<ref kindref="member" refid="group__group__hal__syspm_1gga144e474d3bfb544b207f172d1d8bd633acd2a5522b6591eb77418369e464a3eb1">CYHAL_SYSPM_SYSTEM_NORMAL</ref>) - This is a normal operating state for the device. This is exposed by <ref kindref="member" refid="group__group__hal__syspm_1gaae0157682bad1b2155738e73347afa87">cyhal_syspm_set_system_state</ref>.</para></listitem><listitem><para>Low (<ref kindref="member" refid="group__group__hal__syspm_1gga144e474d3bfb544b207f172d1d8bd633af4060b98561e43a6b930576644af014f">CYHAL_SYSPM_SYSTEM_LOW</ref>) - This is a lower power operating state that may be supported by the device. This state often imposes specific requirements on clock speeds and voltage levels. See the device specific documentation for any device specific requirements for this mode, or whether it is even supported. If the device supports this mode, it is exposed by <ref kindref="member" refid="group__group__hal__syspm_1gaae0157682bad1b2155738e73347afa87">cyhal_syspm_set_system_state</ref>.</para></listitem><listitem><para>Hibernate - This is the lowest available power state. In this state most of the chip is powered down. It has a very limited number of wakeup sources, and may require the device to reboot in order to come back up. It can be accessed by calling <ref kindref="member" refid="group__group__hal__syspm_1ga507445e44ab6aae0f4cbaabaec6c5a3f">cyhal_syspm_hibernate</ref>.</para></listitem></itemizedlist>
</para><para>Any time a power state transition is requested a series of callbacks are invoked. This allows peripherals, or other parts of the application, to confirm they are not currently doing something that would not work in the requested power state. HAL Peripheral drivers automatically register these callbacks when they are initialized. The application also has the option to register a callback function(s) to be called on requested state transitions by callling <ref kindref="member" refid="group__group__hal__syspm_1ga5d1637ece9b27528636981acfc893fd3">cyhal_syspm_register_callback</ref>. If registered, the application level callbacks are invoked first. This gives the application a chance stop any peripherals, if appropriate, to ensure the power transition can actually happen. Alternatively it can directly reject the transition. Each callback registered can specify the exact set of states ( <ref kindref="member" refid="group__group__hal__syspm_1ga560aa7873d3131c4eb5d1453711305d2">cyhal_syspm_callback_state_t</ref> ) that it should be called for. Each callback is invoked multiple times as part of the transition process as defined by <ref kindref="member" refid="group__group__hal__syspm_1ga5a6a88eb2b6e35dbea25e36b027bf4ba">cyhal_syspm_callback_mode_t</ref>.</para><para>At any point the code can lock the ability to enter deep sleep by calling <ref kindref="member" refid="group__group__hal__syspm_1ga3568214a6038240239f99768fe6707d6">cyhal_syspm_lock_deepsleep</ref>. This should be done in critical blocks that need to continue remain active. When the critical work is complete, and the lock is no longer needed, it can be released by calling <ref kindref="member" refid="group__group__hal__syspm_1ga028b85f03d4607ccac8494b46ec8413c">cyhal_syspm_unlock_deepsleep</ref>. The lock is a counter with a max count of USHRT_MAX. It must be locked/unlocked an equal number of times before the device is actually able to enter deep sleep.</para><para>All peripherals are expected to operate in the default Active/Normal power state. Some peripherals (primarily analog) can operate in lower power states as well. These drivers will operate in all power states that the hardware supports.</para><para>When power transitions are requested each type of peripheral has a default behavior. Peripherals that can continue to operate in the requested power mode do not interfere. Peripherals that are not currently active allow the transition, but make sure they restore their state if needed for when the device comes back. Peripherals that are active and cannot continue to work in the requested power state will block the transition.</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;The power management functionality available depends on the availability of the features in the hardware. For detailed information about exactly what is supported on each device, refer to the Device Datasheet or Technical Reference Manual (TRM).&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim></para>
<para><heading level="1">Features</heading></para>
<para>This driver provides control over multiple different types of power management and when those transitions are allowed:<itemizedlist>
<listitem><para>Change CPU Power State: APIs to allow changing the current CPU state into one of the lower power CPU states (SLEEP, DEEPSLEEP)</para></listitem><listitem><para>Change System Power State: An API allows for changing the system wide power state between one of states (NORMAL, LOW)</para></listitem><listitem><para>Hibernate: An API that allows to set the hibernate wakeup source and set the system state to Hibernate.</para></listitem><listitem><para>General Purpose Power State Transition Callback: APIs allow for registering/unregistering a callback function to be notified when various power state transitions happen. If registered, the application can do anything necessary at power transitions. It can even prevent the transition if need-be.</para></listitem><listitem><para>Peripheral Specific Power State Transition Callback: APIs allow for registering/unregistering a callback function to be called when a peripheral with a CUSTOM power mode strategy exists and a power mode transition is requested. This allows the application to customize when it is OK for the peripheral to enter a low power state.</para></listitem><listitem><para>Lock DeepSleep: APIs to prevent/allow the CPU from going to deep sleep. This is a convenience API rather than needing to implement a full Transition Callback handler.</para></listitem></itemizedlist>
</para>

<para><heading level="1">Quick Start</heading></para>
<para>Unlike most HAL drivers this does not require initializing an instance object. The APIs provided here can be called at anytime. See the snippets below for examples of how to use this driver.</para>

<para><heading level="1">Code Snippets</heading></para>

<para><bold>Snippet 1: Simple deep sleep locking</bold></para>
<para>The following snippet shows how to use the deep sleep locking APIs to restrict when the device can enter deep sleep. In between the lock/unlock calls any attempt to change power modes will automatically be canceled. <programlisting filename="syspm.c"><codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__syspm_1ga3568214a6038240239f99768fe6707d6">cyhal_syspm_lock_deepsleep</ref>();</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Perform<sp />work<sp />that<sp />should<sp />not<sp />be<sp />interrupted<sp />by<sp />deepsleep<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__syspm_1ga028b85f03d4607ccac8494b46ec8413c">cyhal_syspm_unlock_deepsleep</ref>();</highlight></codeline>
</programlisting> </para>

<para><bold>Snippet 2: Calling different power state functions</bold></para>
<para>The following snippet shows the different functions that exist to change power states on the device and how they can each be called. <programlisting filename="syspm.c"><codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp />rslt;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Put<sp />the<sp />MCU<sp />to<sp />sleep.<sp />Peripherals<sp />will<sp />continue<sp />to<sp />operate.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />rslt<sp />=<sp /><ref kindref="member" refid="group__group__hal__syspm_1gac3e07ce98d215865b0f7f0149073bae2">cyhal_syspm_sleep</ref>();</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Put<sp />the<sp />MCU<sp />to<sp />deep-sleep.<sp />Many<sp />peripherals<sp />will<sp />also<sp />stop.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />rslt<sp />=<sp /><ref kindref="member" refid="group__group__hal__syspm_1ga0afe7e58c0df4a2eda5010ac628ea981">cyhal_syspm_deepsleep</ref>();</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Put<sp />the<sp />system<sp />into<sp />a<sp />hibernate<sp />state.<sp />Most<sp />of<sp />the<sp />system<sp />will<sp />stop.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />rslt<sp />=<sp /><ref kindref="member" refid="group__group__hal__syspm_1ga507445e44ab6aae0f4cbaabaec6c5a3f">cyhal_syspm_hibernate</ref>(<ref kindref="member" refid="group__group__hal__syspm_1gga716955af458772e538910575cbf6e1dda519c726a562e214bd1694137e62a22e1">CYHAL_SYSPM_HIBERNATE_WDT</ref>);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Put<sp />the<sp />system<sp />into<sp />a<sp />low<sp />power<sp />state.<sp />Peripherals<sp />will<sp />continue<sp />to<sp />work,</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />but<sp />some<sp />may<sp />have<sp />restrictions<sp />on<sp />operating<sp />clock<sp />frequency<sp />or<sp />voltages.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />rslt<sp />=<sp /><ref kindref="member" refid="group__group__hal__syspm_1gaae0157682bad1b2155738e73347afa87">cyhal_syspm_set_system_state</ref>(<ref kindref="member" refid="group__group__hal__syspm_1gga144e474d3bfb544b207f172d1d8bd633af4060b98561e43a6b930576644af014f">CYHAL_SYSPM_SYSTEM_LOW</ref>);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
</programlisting> </para>

<para><bold>Snippet 3: Using callbacks for application power management</bold></para>
<para>The following snippet shows how to use the callback mechanisms to manage whether it is safe to enter low power modes. <programlisting filename="syspm.c"><codeline><highlight class="keywordtype">bool</highlight><highlight class="normal"><sp />syspm_app_callback(<ref kindref="member" refid="group__group__hal__syspm_1ga560aa7873d3131c4eb5d1453711305d2">cyhal_syspm_callback_state_t</ref><sp />state,<sp /><ref kindref="member" refid="group__group__hal__syspm_1ga5a6a88eb2b6e35dbea25e36b027bf4ba">cyhal_syspm_callback_mode_t</ref><sp />mode,<sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />*callback_arg)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />(void)callback_arg;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordtype">bool</highlight><highlight class="normal"><sp />allow_transition<sp />=<sp /></highlight><highlight class="keyword">true</highlight><highlight class="normal">;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">switch</highlight><highlight class="normal"><sp />(mode)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__hal__syspm_1gga5a6a88eb2b6e35dbea25e36b027bf4baa1d8aad9b05d313a22e7666a98414f26d">CYHAL_SYSPM_CHECK_READY</ref>:</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Check<sp />to<sp />see<sp />if<sp />it<sp />is<sp />OK<sp />to<sp />change<sp />power<sp />modes.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />If<sp />it<sp />is<sp />OK<sp />the<sp />change,<sp />make<sp />sure<sp />nothing<sp />will<sp />invalidate<sp />this<sp />and<sp />return<sp />true.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />If<sp />it<sp />is<sp />not<sp />OK<sp />the<sp />change,<sp />return<sp />false.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Example:<sp />prevent<sp />transition<sp />if<sp />requested<sp />mode<sp />is<sp />HIBERNATE.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />allow_transition<sp />=<sp />(state<sp />!=<sp /><ref kindref="member" refid="group__group__hal__syspm_1gga560aa7873d3131c4eb5d1453711305d2ac9de4348b02a53d947ce48bd7bc6922a">CYHAL_SYSPM_CB_SYSTEM_HIBERNATE</ref>);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__hal__syspm_1gga5a6a88eb2b6e35dbea25e36b027bf4baa190eae9b4e71d4c245038320880dcca3">CYHAL_SYSPM_CHECK_FAIL</ref>:</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Undo<sp />anything<sp />done<sp />as<sp />part<sp />of<sp />CHECK_READY<sp />since<sp />it<sp />is<sp />not<sp />actually<sp />chaning.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__hal__syspm_1gga5a6a88eb2b6e35dbea25e36b027bf4baadd83c77cb81d9d4aafef1d094e6c4e71">CYHAL_SYSPM_BEFORE_TRANSITION</ref>:</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Do<sp />anything<sp />necessary<sp />to<sp />shut<sp />things<sp />down.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">case</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__hal__syspm_1gga5a6a88eb2b6e35dbea25e36b027bf4baaf6a195dbd042da0bffc35b9161ca49e6">CYHAL_SYSPM_AFTER_TRANSITION</ref>:</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Undo<sp />anything<sp />done<sp />as<sp />part<sp />of<sp />CHECK_READY<sp />or<sp />BEFORE_TRANSITION<sp />since<sp />it<sp />is<sp />coming<sp />back<sp />up.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">break</highlight><highlight class="normal">;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />allow_transition;</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />snippet_cyhal_syspm_app_callback(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp />rslt;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcyhal__syspm__callback__data__t">cyhal_syspm_callback_data_t</ref><sp />callback_data<sp />=</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.<ref kindref="member" refid="structcyhal__syspm__callback__data__t_1aacd72d2e829b54c27e98e6495ca4dfd8">callback</ref><sp />=<sp />syspm_app_callback,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.states<sp />=<sp />(<ref kindref="member" refid="group__group__hal__syspm_1ga560aa7873d3131c4eb5d1453711305d2">cyhal_syspm_callback_state_t</ref>)(<ref kindref="member" refid="group__group__hal__syspm_1gga560aa7873d3131c4eb5d1453711305d2ac9de4348b02a53d947ce48bd7bc6922a">CYHAL_SYSPM_CB_SYSTEM_HIBERNATE</ref><sp />|<sp /><ref kindref="member" refid="group__group__hal__syspm_1gga560aa7873d3131c4eb5d1453711305d2af13d1c94115a90b1f9d734ace0017045">CYHAL_SYSPM_CB_SYSTEM_LOW</ref>),</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.args<sp />=<sp />NULL,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.next<sp />=<sp />NULL,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__syspm_1ga5d1637ece9b27528636981acfc893fd3">cyhal_syspm_register_callback</ref>(&amp;callback_data);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Attempt<sp />to<sp />hibernate.<sp />This<sp />will<sp />be<sp />rejected<sp />by<sp />the<sp />callback.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />rslt<sp />=<sp /><ref kindref="member" refid="group__group__hal__syspm_1ga507445e44ab6aae0f4cbaabaec6c5a3f">cyhal_syspm_hibernate</ref>(<ref kindref="member" refid="group__group__hal__syspm_1gga716955af458772e538910575cbf6e1dda2a495fcdf84252843b6fc9bc4e27206a">CYHAL_SYSPM_HIBERNATE_RTC_ALARM</ref>);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref><sp />!=<sp />rslt)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />If<sp />couldn't<sp />go<sp />to<sp />hibernate,<sp />try<sp />deep<sp />sleep.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />rslt<sp />=<sp /><ref kindref="member" refid="group__group__hal__syspm_1ga0afe7e58c0df4a2eda5010ac628ea981">cyhal_syspm_deepsleep</ref>();</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__syspm_1gae069670790199a668edffa9ec01fd538">cyhal_syspm_unregister_callback</ref>(&amp;callback_data);</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
</programlisting></para>

    </detaileddescription>
  </compounddef>
</doxygen>